commit 01a70ccd723eb9a479186fe37c972b0d0f8676cf
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Fri Jan 7 16:21:03 2022

    libstdc++: Add -nostdinc++ for c++17 sources [PR100017]
    
    When building a build!=host compiler, the just-built gcc can't be used
    to build the target libstdc++ (because it is built for the host triplet,
    not the build triplet). The top-level configure.ac sets up the build
    flags for libstdc++ (and other "raw_cxx" libs) like this:
    
    GCC_TARGET_TOOL(c++ for libstdc++, RAW_CXX_FOR_TARGET, CXX,
                    [gcc/xgcc -shared-libgcc -B$$r/$(HOST_SUBDIR)/gcc -nostdinc++ -L$$r/$(TARGET_SUBDIR)/libstdc++-v3/src -L$$r/$(TARGET_SUBDIR)/libstdc++-v3/src/.libs -L$$r/$(TARGET_SUBDIR)/libstdc++-v3/libsupc++/.libs],
                    c++)
    
    The -nostdinc++ flag is only used for the IN-TREE-TOOL, i.e. when using
    the just-built gcc/xgcc compiler. This means that the cross-compiler
    used to build libstdc++ will add its own libstdc++ headers to the
    include path. That results in the #include <cfenv> in
    src/c++17/floating_to_chars.cc and src/c++17/floating_from_chars.cc
    doing #include_next <fenv.h> and finding the libstdc++ fenv.h wrapper
    from the host compiler. Because that has the same include guard as the
    <fenv.h> in the libstdc++ we're trying to build, we never reach the
    underlying <fenv.h> from libc. That results in several errors of the
    form:
    
    error: 'fenv_t' has not been declared in '::'
    
    The most correct fix would be to add -nostdinc++ to the
    RAW_CXX_FOR_TARGET variable in configure.ac, or the
    RAW_CXX_TARGET_EXPORTS variable in Makefile.tpl.
    
    Another solution would be to make the libstdc++ <fenv.h> wrapper use
    _GLIBCXX_INCLUDE_NEXT_C_HEADERS like our <stdlib.h> and other C header
    wrappers.
    
    For now though, the simplest and safest solution is to just add
    -nostdinc++ to the CXXFLAGS used for src/c++17/*.cc, which is what this
    does.
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/100017
            * src/c++17/Makefile.am (AM_CXXFLAGS): Add -nostdinc++.
            * src/c++17/Makefile.in: Regenerate.
    
    (cherry picked from commit 4fde88e5dd152fe866a97b12e0f8229970d15cb3)

diff --git a/libstdc++-v3/src/c++17/Makefile.am b/libstdc++-v3/src/c++17/Makefile.am
index cb94aff5f1a..2aebc6d5251 100644
--- a/libstdc++-v3/src/c++17/Makefile.am
+++ b/libstdc++-v3/src/c++17/Makefile.am
@@ -79,7 +79,7 @@ endif
 # OPTIMIZE_CXXFLAGS on the compile line so that -O2 can be overridden
 # as the occasion calls for it.
 AM_CXXFLAGS = \
-	-std=gnu++17 \
+	-std=gnu++17 -nostdinc++ \
 	$(glibcxx_lt_pic_flag) $(glibcxx_compiler_shared_flag) \
 	$(XTEMPLATE_FLAGS) $(VTV_CXXFLAGS) \
 	$(WARN_CXXFLAGS) $(OPTIMIZE_CXXFLAGS) $(CONFIG_CXXFLAGS) \
